package de.tu_darmstadt.tk.SmartHomeNetworkSim.view;

import java.awt.Dimension;
import java.util.LinkedList;

import javax.swing.JFrame;

import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.Link;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.SmartDevice;
import de.tu_darmstadt.tk.SmartHomeNetworkSim.core.simpleImplementation.SimpleLink;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.JComboBox;
import javax.swing.JButton;

@SuppressWarnings("serial")
public class LinkCreationPanel extends JScrollPane{
	
	JPanel content;
	private JTextField tfName;
	public LinkCreationPanel() {
		setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		this.setPreferredSize(new Dimension(600, 400));
		content = new JPanel();
		content.setPreferredSize(new Dimension(600,1000));
		this.setViewportView(content);
		content.setLayout(null);
		
		JLabel lblDescription = new JLabel("Create a new Link");
		lblDescription.setBounds(12, 13, 476, 16);
		content.add(lblDescription);
		
		JLabel lblName = new JLabel("Name:");
		lblName.setHorizontalAlignment(SwingConstants.RIGHT);
		lblName.setBounds(12, 42, 138, 16);
		content.add(lblName);
		
		tfName = new JTextField();
		tfName.setText("LinkName");
		tfName.setBounds(162, 39, 116, 22);
		content.add(tfName);
		tfName.setColumns(10);
		
		JLabel lblLinkType = new JLabel("Type:");
		lblLinkType.setHorizontalAlignment(SwingConstants.RIGHT);
		lblLinkType.setBounds(12, 71, 138, 16);
		content.add(lblLinkType);
		
		JComboBox<String> cmbLinkType = new JComboBox<String>();
		cmbLinkType.addItem("SimpleLink");
		cmbLinkType.addItem("ZigbeeNetwork");
		cmbLinkType.setBounds(162, 68, 116, 22);
		content.add(cmbLinkType);
		
		content.setPreferredSize(new Dimension(500,1000));
		
		JButton btnImportLink = new JButton("Import Link Type");
		btnImportLink.setBounds(290, 67, 144, 25);
		content.add(btnImportLink);
		
		JButton btnCreate = new JButton("Verify and Create");
		btnCreate.setBounds(121, 103, 206, 25);
		content.add(btnCreate);
		
		JLabel lblDeviceA = new JLabel("DeviceA:");
		lblDeviceA.setHorizontalAlignment(SwingConstants.RIGHT);
		lblDeviceA.setBounds(12, 141, 138, 16);
		content.add(lblDeviceA);
		
		JLabel lblDeviceb = new JLabel("DeviceB:");
		lblDeviceb.setHorizontalAlignment(SwingConstants.RIGHT);
		lblDeviceb.setBounds(12, 170, 138, 16);
		content.add(lblDeviceb);
		
		JLabel lblDeviceC = new JLabel("DeviceC:");
		lblDeviceC.setHorizontalAlignment(SwingConstants.RIGHT);
		lblDeviceC.setBounds(12, 199, 138, 16);
		content.add(lblDeviceC);
		
		JComboBox<String> comboBox = new JComboBox<String>();
		comboBox.addItem("Router");
		comboBox.addItem("Client");
		comboBox.addItem("not participating");
		comboBox.setBounds(162, 138, 165, 22);
		content.add(comboBox);
		
		JComboBox<String> comboBox_1 = new JComboBox<String>();
		comboBox_1.addItem("Router");
		comboBox_1.addItem("Client");
		comboBox_1.addItem("not participating");
		comboBox_1.setBounds(162, 167, 165, 22);
		content.add(comboBox_1);
		
		JComboBox<String> comboBox_2 = new JComboBox<String>();
		comboBox_2.addItem("Router");
		comboBox_2.addItem("Client");
		comboBox_2.addItem("not participating");
		comboBox_2.setBounds(162, 196, 165, 22);
		content.add(comboBox_2);
	}

	
	 /**
     * Test the Panel
     */
    private static void testGUI() {
        JFrame frame = new JFrame("LinkCreation Panel");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        SmartDevice test = new SmartDevice("TestDevice");
        LinkedList<SmartDevice> devicesOfLink = new LinkedList<SmartDevice>();
        devicesOfLink.add(test);
        Link testNet = new SimpleLink("Test Network");
        testNet.addDevice(test);
        LinkCreationPanel panel = new LinkCreationPanel();
        frame.setContentPane(panel);
        frame.pack();
        frame.setVisible(true);
    }

 
    public static void main(String[] args) {
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                testGUI();
            }
        });
    }
}